// 完毕：
using System.IO;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Pdf.AcroForms;

namespace DsPdfWeb.Demos
{
    // 此示例演示如何从 PDF 中查找和删除签名字段。
    // 此示例​​中的代码与RemoveSignatures中的代码几乎相同，
    // 它还会找到所有签名字段，但仅删除签名，留下字段。
    // 本示例中使用的 PDF 是由 TimeSheet 创建的。
    public class RemoveSignatureFields
    {
        public int CreatePDF(Stream stream)
        {
            var doc = new GcPdfDocument();
            using (var fs = File.OpenRead(Path.Combine("Resources", "PDFs", "TimeSheet.pdf")))
            {
                doc.Load(fs);

                // 字段可以是其他字段的子字段，因此我们使用
                // 迭代整个树的递归方法：
                removeSignatureFields(doc.AcroForm.Fields);

                // 完毕：
                doc.Save(stream);
                return doc.Pages.Count;

                void removeSignatureFields(FieldCollection fields)
                {
                    for (int i = fields.Count - 1; i >= 0; --i)
                    {
                        removeSignatureFields(fields[i].Children);
                        // 注意：如果我们只是想删除签名
                        // 在不删除字段本身的情况下，我们会这样做：
                        // ((SignatureField)fields[i]).Value = null;
                        if (fields[i] is SignatureField)
                            fields.RemoveAt(i);
                    }
                }
            }
        }
    }
}
